<?php

class Webmoney extends PaymentModule
{
	private	$_html = '';
	private $_postErrors = array();

	public function __construct()
	{
		$this->name = 'webmoney';
		$this->tab = 'Payment';
		$this->version = '0.1';
		
		$this->currencies = true;
		$this->currencies_mode = 'radio';

        parent::__construct();

        /* The parent construct is required for translations */
		$this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('WebMoney');
        $this->description = $this->l('Оплата через платежную систему WebMoney');
		$this->confirmUninstall = $this->l('Вы действиетельно хотите удалить?');
	}

	public function install()
	{
		if (!parent::install() OR !Configuration::updateValue('WEBMONEY_PURSE', 'R000000000000')
							   OR !Configuration::updateValue('WEBMONEY_KEY', '123456789')
							   OR !$this->registerHook('payment'))
							   return false;
		return true;
	}

	public function uninstall()
	{
		if (!Configuration::deleteByName('WEBMONEY_PURSE')
			OR !Configuration::deleteByName('WEBMONEY_KEY')
			OR !parent::uninstall())
			return false;
		return true;
	}

	public function getContent()
	{
		$this->_html = '<h2>WebMoney</h2>';
		if (isset($_POST['submitWebmoney']))
		{
			if (empty($_POST['purse']))
				$this->_postErrors[] = $this->l('заполните');
				if (empty($_POST['key']))
				$this->_postErrors[] = $this->l('заполните');
		
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('WEBMONEY_PURSE', $_POST['purse']);
				Configuration::updateValue('WEBMONEY_KEY', $_POST['key']);
				$this->displayConf();
			}
			else
				$this->displayErrors();
		}

		$this->displayWebMoney();
		$this->displayFormSettings();
		return $this->_html;
	}

	public function displayConf()
	{
		$this->_html .= '
		<div class="conf confirm">
		<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
		'.$this->l('Настройки обновлены').'
		</div>';
	}

	public function displayErrors()
	{
		$nbErrors = sizeof($this->_postErrors);
		$this->_html .= '
		<div class="alert error">
		<h3>'.($nbErrors > 1 ? $this->l('There are') : $this->l('There is')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3><ol>';
		foreach ($this->_postErrors AS $error)
		$this->_html .= '<li>'.$error.'</li>';
		$this->_html .= '</ol></div>';
	}
	
	
	public function displayWebMoney()
	{
		$this->_html .= '
		<img src="../modules/webmoney/logo_silver-small.png" style="float:left; margin-right:15px;" />
		<b>'.$this->l('Модуль оплаты WebMoney.').'</b><br /><br />
		<br /><br />';
	}

	public function displayFormSettings()
	{
		$conf = Configuration::getMultiple(array('WEBMONEY_PURSE', 'WEBMONEY_KEY'));
		$purse = array_key_exists('purse', $_POST) ? $_POST['purse'] : (array_key_exists('WEBMONEY_PURSE', $conf) ? $conf['WEBMONEY_PURSE'] : '');
		$key = array_key_exists('key', $_POST) ? $_POST['key'] : (array_key_exists('WEBMONEY_KEY', $conf) ? $conf['WEBMONEY_KEY'] : '');
		
		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Настройки').'</legend>
			<div><label>'.$this->l('Номер кошелька').'</label>
			<div class="margin-form"><input type="text" size="33" maxlength="13" name="purse" value="'.htmlentities($purse, ENT_COMPAT, 'UTF-8').'" />
			<p>Формат: буква и 12 цифр</p></div>
			<div><label>'.$this->l('Ключ').'</label>
			<div class="margin-form"><input type="text" size="33" maxlength="13" name="key" value="'.htmlentities($key, ENT_COMPAT, 'UTF-8').'" />
			<p>Secret Key</p></div>			
			</div>
			<br /><center><input type="submit" name="submitWebmoney" value="'.$this->l('Сохранить').'" class="button" /></center>
		</fieldset>
		</form><br /><br />
		<fieldset class="width3">
			<legend><img src="../img/admin/warning.gif" />'.$this->l('Информация').'</legend>
			<b style="color: red;">'.$this->l('Что бы подключить оплату через WebMoney:').'</b><br />
			'.$this->l('
На сайте <b>https://merchant.webmoney.ru</b> выберите пункт меню &quot;Настройки&quot;. Пройдите авторизацию и выберите кошелек, на который вы будете принимать платежи   через сервис Web Merchant Interface. Вы получите страницу для настройки   параметров. <br />
<br />
Ниже приведен перечень заполняемых значений:</p>
<ul>
  <li><b>Торговое имя:</b> Торговое имя (это название отображается на странице при оплате)</li>
  <li><b>Secret Key:</b> Придумайте Ваш секретный код платежа, должен знать только Ваш интернет-магазин и Webmoney</li>
  <li><b>Тестовый/Рабочий режим:</b> Тестовый - для тестов, Рабочий - для приема платежей<br />
  </li>
  <li><b>Позволять использовать URL, передаваемые в форме:</b> отмечен<br />
  </li>
</ul>
').'
<br />
		</fieldset>';
	}




	public function hookPayment($params)
	{
		global $smarty;

		$customer = new Customer(intval($params['cart']->id_customer));
		$purse = Configuration::get('WEBMONEY_PURSE');
		$currency = $this->getCurrency();
				
		$smarty->assign(array(
			'customer' => $customer,
			'purse' => $purse,
			'currency' => $currency,
			'amount' => number_format(Tools::convertPrice($params['cart']->getOrderTotal(true, 4), $currency), 0, '.', ''),
			'total' => number_format(Tools::convertPrice($params['cart']->getOrderTotal(true, 3), $currency), 0, '.', ''),
			'id_cart' => intval($params['cart']->id),
			'goBackUrl' => 'http://'.htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'order-confirmation.php?key='.$customer->secure_key,
			'returnUrl' => 'http://'.htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'modules/webmoney/validation.php',
			'cancelUrl' => 'http://'.htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__.'order.php',
			'this_path' => $this->_path
		));

		return $this->display(__FILE__, 'webmoney.tpl');
    }		
}
?>
